#include <proto.h>

#include "gtdrawable.h"
#include "gterror.h"

/************************************************************************\
*
* GtDrawable class.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/************************************************************************\
*
* Setup empty drawable.
*
\************************************************************************/
GtDrawable::GtDrawable(void)
{
	dsp=NULL;
	dr=0;
}

/************************************************************************\
*
* Setup drawable.
*
\************************************************************************/
sbool GtDrawable::Init(GtDisplay *d,GtTag *tgs)
{
	GtTag *t;
	
	dsp=d;
	while((t=GtNextTag(&tgs)))
	{
		switch(t->tag)
		{
			case GT_Display:
				dsp=(GtDisplay *)t->d.ptr;
				break;
		}
	}
	if(!dsp)
	{
		GtError(this,GTEC_NODISPLAY,"No GtDisplay!\n");
		return(FALSE);
	}
	return(TRUE);
}

/************************************************************************\
*
* Find display tag and then setup normal.
*
\************************************************************************/
sbool GtDrawable::Init(GtTag *tgs)
{
	GtDisplay *d;
	
	d=(GtDisplay *)GtGetTagPtr(tgs,GT_Display,NULL);
	return(this->Init(d,tgs));
}

/************************************************************************\
*
* Get drawable attributes.
*
\************************************************************************/
void GtDrawable::Get(GtTag *tgs)
{
	GtTag *t;
	long *ptr;

	while((t=GtNextTag(&tgs)))
	{
		if(!(ptr=(long *)t->d.ptr))
			continue;
		switch(t->tag)
		{
			case GT_Display:
				*ptr=(long)dsp;
				break;
			case GT_XDrawable:
				*ptr=(long)dr;
				break;
		}
	}
}

/************************************************************************\
*
* Check if class is (sub)class of named class.
*
\************************************************************************/
sbool GtDrawable::IsSubClassOf(char *cn)
{
	if(strcmp(cn,"GtDrawable")==0)
		return(TRUE);
	else
		return(GtBase::IsSubClassOf(cn));
}
