#ifndef INC_DLINK_H
#define INC_DLINK_H

/************************************************************************\
*
* Header for circular doubly linked list with list head for 'tagorg'.
*
* $Copyright: (C) 1997 by Gran Gustafsson $ 
*
\************************************************************************/

/* Macro for creating initialized link heads */
#define DLinkHD(v) DLink v={v,v}

/* Macros for link traversal no error tests */
#define DL_FIRST(hdl)   ((hdl)->next!=(hdl) ? (hdl)->next : NULL)
#define DL_LAST(hdl)    ((hdl)->prev!=(hdl) ? (hdl)->prev : NULL)
#define DL_NEXT(hdl,dl) ((dl)->next!=(hdl) ? (dl)->next : NULL)
#define DL_PREV(hdl,dl) ((dl)->prev!=(hdl) ? (dl)->prev : NULL)
#define DL_EMPTY(hdl)   ((hdl)->next==(hdl))

/* Structure of list link */
struct DLink {
	struct DLink *prev;
	struct DLink *next;
};

typedef struct DLink DLink;


/* Function prototypes */

extern void dl_InitHD(DLink *dl);
extern void dl_AddAfter(DLink *adl,DLink *dl);
extern void dl_AddBefore(DLink *bdl,DLink *dl);
extern void dl_AddHead(DLink *hdl,DLink *dl);
extern void dl_AddTail(DLink *hdl,DLink *dl);
extern void *dl_Remove(DLink *dl);
extern void *dl_RemHead(DLink *hdl);
extern void *dl_RemTail(DLink *hdl);
extern void *dl_First(DLink *hdl);
extern void *dl_Last(DLink *hdl);
extern void *dl_Next(DLink *hdl,DLink *dl);
extern void *dl_Prev(DLink *hdl,DLink *dl);
extern int dl_Empty(DLink *hdl);

#endif /* INC_DLINK_H */
